
#include <CapacitiveSensor.h>
// constants won't change. They're used here to set pin numbers:
const int buttonPin = 13;     // the number of the pushbutton pin
long capSensorMin = 10000;
long capSensorMax = 0;
long calibratedMin;
long calibratedMax;
int buttonState = LOW;
long capSensorValue;
int capValue=0;
float alpha = 0.6;
long capSensorFiltered = 0;
int buttonval=0;
int numSamples = 20; 
char *etichette[] = {"B ","C ","D ","E ","F ","H "};
CapacitiveSensor   cs_4_2 = CapacitiveSensor(4,2);    
//variable for controlling previous value and avoid continuous flow of data
int prev_sensval[] {0,0,0,0,0,0,0};
int LDRValue = 0;   
int LDRMin = 1023;  
int LDRMax = 0;    
int switch_pin=8;
int et;
 
void setup() {
  pinMode(buttonPin, INPUT);
  pinMode(switch_pin, INPUT);
  
   cs_4_2.set_CS_AutocaL_Millis(0xFFFFFFFF);     // turn off autocalibrate on channel 1 - just as an example
   lowpass();
   calibration();
   delay(5000);
   
   while (millis() < 7000) {
    
    LDRValue = analogRead(A5);
    
    // record the maximum sensor value
    if (LDRValue > LDRMax) {
      LDRMax = LDRValue;
    }
    // record the minimum sensor value
    if (LDRValue < LDRMin) {
      LDRMin = LDRValue;
    }
  }

  Serial.begin(9600);
  // initialize the LED pin as an output:
 
  // initialize the pushbutton pin as an input:
  
  
}

void loop() {
  
    if(Serial.available() > 0){
      numSamples = Serial.parseInt();
      alpha = Serial.parseFloat();
    }
    long start = millis();
    capSensorValue =  cs_4_2.capacitiveSensor(numSamples);
    lowpass();
    LDRValue = analogRead(A5);
    

  LDRValue = map(LDRValue, LDRMin, LDRMax, 0, 1023); 
  LDRValue = constrain(LDRValue, 0, 1023);
  Serial.print("G ");
  Serial.println(LDRValue);
  int sensor1 = analogRead(A0);
  int sensor1_2 = analogRead(A0);
  int sensor2 = analogRead(A1); 
  int sensor3 = analogRead(A2);
  int sensor4 = analogRead(A3);
  int sensor5 = analogRead(A4);
  
  if(digitalRead(switch_pin) == LOW){
     checkvalue(sensor1,0);
  }else{
    checkvalue(sensor1_2,5);
  }
  
  checkvalue(sensor2,1);
  checkvalue(sensor3,2);
  checkvalue(sensor4,3);
  checkvalue(sensor5,4);
  
  
  // read the state of the pushbutton value:
  buttonState = digitalRead(buttonPin);
  
  // check if the pushbutton is pressed. If it is, the buttonState is HIGH:
   if(digitalRead(switch_pin) == LOW){
  et=0;
  button_check(et);
   }else{
    et=1;
    button_check(et);
   }
   
   
    if(digitalRead(switch_pin) == HIGH){
      
    
     Serial.print("L ");
     Serial.println(capSensorFiltered); 
  
    }
   
                           
  delay(2);
}
void lowpass(){
  /* implements an exponentially moving average
   * St = α * Yt + (1 - α) * St-1
   * St is the result of the EMA at time t, 
   * Yt is the sensor measurement at time t, 
   * and α is a coefficient in the range <0,1>    
   * A low α will be very slow to rapid input changes and take many samples into account. 
   * A high α will be fast, but average over fewer samples. 
   * You can look at α as kind of a cutoff frequency in a low-pass filter.
   */ 


   capSensorFiltered = (alpha * capSensorValue) + ((1 - alpha) * capSensorFiltered);
   delay(2);
}

void calibration(){
  
      
      if(capSensorFiltered < capSensorMin){
        capSensorMin = capSensorFiltered;
      }
      if(capSensorFiltered > capSensorMax){
        capSensorMax = capSensorFiltered;
      }
      calibratedMin = capSensorMin;
      calibratedMax = capSensorMax;
      
    
    }
    void checkvalue(int sensor, int index){
     int pre_val=prev_sensval[index];
        if(sensor > pre_val+2 || sensor < pre_val-2){
           Serial.print(etichette[index]); 
           Serial.println(sensor); 


          prev_sensval[index]=sensor;
        }
        }
    void button_check( int et_c){    
        if (buttonState == HIGH) {
    buttonval =1;
    if(et_c == 0){
    Serial.print("A ");
    Serial.println(buttonval);
    }else{
      Serial.print("I ");
    Serial.println(buttonval);
    }
    buttonval=0; 
    //buttonState=LOW;
    delay(300);
    } else {
    if(et_c == 0){
    Serial.print("A ");
    Serial.println(buttonval);
    }else{
      Serial.print("I ");
    Serial.println(buttonval);
    }
    }
    }
    
    
